SystemOrganization addCategory: #'Volunteer-Showcase-Web'!

WAComponent subclass: #LoginView
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Showcase-Web'!

!LoginView class methodsFor: 'class initialization' stamp: 'RG 10/31/2012 13:58'!
initialize 
	"LoginView initialize"
	WAAdmin register: self asApplicationAt: 'login'! !

!LoginView methodsFor: 'rendering' stamp: 'RG 11/2/2012 18:52'!
renderContentOn: html
	html form: [
		html table: [
		self renderLoginOn: html.  
     		self renderPasswordOn: html.  
		self renderSubmitOn: html. ]
	].! !

!LoginView methodsFor: 'rendering' stamp: 'RG 11/2/2012 18:48'!
renderLoginOn: html
	html tableRow: [
		html tableHeading: 'Login:'.
		html tableData: [
			html textInput on: #login of: self user.	
		]  	
	]    ! !

!LoginView methodsFor: 'rendering' stamp: 'RG 11/2/2012 18:50'!
renderPasswordOn: html
	html tableRow: [
		html tableHeading: 'Password:'.
		html tableData: [  
        		html passwordInput on: #password of: self user. ]
	]    ! !

!LoginView methodsFor: 'rendering' stamp: 'RG 11/2/2012 18:52'!
renderSubmitOn: html
	html tableRow: [
		html tableData: [  
			html submitButton 
			callback: [ self verify  ];
			value: 'Accept'. ]. 
	]    ! !

!LoginView methodsFor: 'rendering' stamp: 'RG 11/2/2012 22:07'!
style 
	^ ''! !

!LoginView methodsFor: 'accessing' stamp: 'RG 10/31/2012 13:42'!
user
	^ user ifNil: [ user := User new. ] ! !

!LoginView methodsFor: 'accessing' stamp: 'RG 10/31/2012 13:43'!
user: aUser
	user := aUser ! !

!LoginView methodsFor: 'as yet unclassified' stamp: 'RG 10/31/2012 15:10'!
verify
	| aUser |
	aUser := LoginVerifier verify: (user login)  password: (user password).   
	(aUser isNil) 
		ifFalse: [  self inform: self user login, 
        			  '---' , self user password.]
		ifTrue: [ self inform: self user login, 
        '--' , self user password , 'Fake.'. ]! !

WAComponent subclass: #RegisterSkillView
	instanceVariableNames: 'skill'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Showcase-Web'!

!RegisterSkillView class methodsFor: 'class initialization' stamp: 'RG 10/31/2012 15:39'!
initialize 
	"RegisterSkillView initialize"
	WAAdmin register: self asApplicationAt: 'regSkill'! !

!RegisterSkillView methodsFor: 'as yet unclassified' stamp: 'RG 11/1/2012 15:50'!
register
	skill save.
	self inform: self skill name, 
       ' Registered '.
	skill := Skill new.! !

!RegisterSkillView methodsFor: 'rendering' stamp: 'RG 11/1/2012 15:42'!
renderContentOn: html
	html form: [
		html text: 'Name:'.
        	html textInput on: #name of: self skill.
        	html break.
        	html text: 'Description:'.
        	html textArea on: #description of: self skill.
	  	html break.
		html text: 'Skills '.
        	html select 
            	list: (SkillCollection default collection).
        	html break.
	  	html submitButton
			onClick: 'return confirm(''Are you sure to make the registration?'')'; 
			callback: [ self register  ];
			value: 'Register'.  
	]   
	
	
	
	 ! !

!RegisterSkillView methodsFor: 'accessing' stamp: 'RG 10/31/2012 15:33'!
skill
	^ skill ifNil: [ skill := Skill new ].  ! !

!RegisterSkillView methodsFor: 'accessing' stamp: 'RG 10/31/2012 15:34'!
skill: aSkill 
	skill := aSkill.! !

WAComponent subclass: #RegisterVolunteerView
	instanceVariableNames: 'volunteer chooser table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Showcase-Web'!

!RegisterVolunteerView class methodsFor: 'class initialization' stamp: 'RG 11/2/2012 17:05'!
initialize 
	"RegisterVolunteerView initialize"
	WAAdmin register: self asApplicationAt: 'regVolunteer'! !

!RegisterVolunteerView methodsFor: 'accessing' stamp: 'RG 11/3/2012 00:04'!
children 
	^ Array with: chooser with: table.  ! !

!RegisterVolunteerView methodsFor: 'initialize-release' stamp: 'RG 11/3/2012 15:31'!
initialize 
	super initialize.
	chooser := SkillChooser new.
	chooser skills: (self volunteer skills).  
	table := RemoveSkillView new.
	table skills: (self volunteer skills).     ! !

!RegisterVolunteerView methodsFor: 'as yet unclassified' stamp: 'RG 11/2/2012 21:57'!
register
	| result |
	
	result := LoginVerifier exists: ( self volunteer login ).
	( result  ) ifTrue: [
		self inform: 'Login already exists.'.  
	]
	ifFalse: [
		volunteer save.
		volunteer := Volunteer new.
		self inform: 'Registered Successfully.'  
	].  ! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/2/2012 17:39'!
renderBirthDayOn: html
	html tableRow: [  
	html tableHeading: 'Birthday'.  
	html tableData: [
		html dateInput
	  		options: #(#day #month #year);  
        		callback: [ :value | self volunteer birthday: value ];
        		with: self volunteer birthday. ]
	]! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/3/2012 00:05'!
renderContentOn: html
	html heading: 'Register Volunteer'.      
	html form: [
		html table: [
			self renderNameOn: html.     	
			self renderBirthDayOn: html.
			self renderEmailOn: html.
			self renderLoginOn: html.  
			self renderPasswordOn: html.
			self renderSubmitOn: html.  
		].  
		html horizontalRule.
		html render: chooser.
		html horizontalRule.
		html render: table.
	]  ! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/2/2012 17:40'!
renderEmailOn: html
	html tableRow: [  
		html tableHeading: 'Email'.
		html tableData: [  
			html textInput on: #email of: self volunteer. ].
	]! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/2/2012 17:42'!
renderLoginOn: html
	html tableRow: [  
		html tableHeading: 'Login'.
		html tableData: [    
			html textInput on: #login of: self volunteer. ].
	]! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/2/2012 17:36'!
renderNameOn: html
	html tableRow: [  
		html tableHeading: 'Name'.
		html tableData:   [ html textInput on: #name of: self volunteer. ]
	]! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/2/2012 17:43'!
renderPasswordOn: html
	html tableRow: [  
		html tableHeading: 'Password'.
		html tableData: [  
			html textInput on: #password of: self volunteer. ].
	]! !

!RegisterVolunteerView methodsFor: 'rendering' stamp: 'RG 11/2/2012 18:20'!
renderSubmitOn: html
	html tableRow: [  
		html tableData: ''.
		html tableData: [  	
			html submitButton
				onClick: 'return confirm(''Are you sure to make the registration?'')'; 
				callback: [ self register  ];
				value: 'Register'. ].  
	]! !

!RegisterVolunteerView methodsFor: 'accessing' stamp: 'RG 11/2/2012 16:56'!
volunteer 
	^ volunteer ifNil: [ volunteer := Volunteer new. ]  ! !

!RegisterVolunteerView methodsFor: 'accessing' stamp: 'RG 11/2/2012 16:57'!
volunteer: aVolunteer 
	volunteer := aVolunteer ! !

WAComponent subclass: #RemoveSkillView
	instanceVariableNames: 'skills chosen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Showcase-Web'!

!RemoveSkillView methodsFor: 'accessing' stamp: 'RG 11/3/2012 15:10'!
chosen 
	^chosen ! !

!RemoveSkillView methodsFor: 'accessing' stamp: 'RG 11/3/2012 15:11'!
chosen: aSkill
	chosen := aSkill ! !

!RemoveSkillView methodsFor: 'accessing' stamp: 'RG 11/3/2012 15:24'!
removeSkill
	| index |
	index := self skills indexOf: chosen ifAbsent: [ ^-1. ].
	(index > -1) 
		ifTrue: [ self skills removeAt: ( index ) ]
		ifFalse: [ Transcript show: 'Error removing skill'; cr. ].
	self answer.! !

!RemoveSkillView methodsFor: 'rendering' stamp: 'RG 11/3/2012 15:24'!
renderContentOn: html
	html form: [
		html table: [
			html tableRow: [
				self renderTitleOn: html.  
				self renderSkillsOn: html.
				self renderSubmitOn: html.  
			]	
		]  
	]! !

!RemoveSkillView methodsFor: 'rendering' stamp: 'RG 11/3/2012 15:11'!
renderSkillsOn: html
	html tableData: [
			html select 
						size: 2;
   				         	list: skills;
						callback: [ :value | self chosen: value. ]. 
	]    ! !

!RemoveSkillView methodsFor: 'rendering' stamp: 'RG 11/3/2012 15:12'!
renderSubmitOn: html
	html tableData: [  	
			html submitButton
				callback: [ self removeSkill ];
				value: 'Remove'. 
	].      ! !

!RemoveSkillView methodsFor: 'rendering' stamp: 'RG 11/3/2012 15:26'!
renderTitleOn: html
	html heading level: 2; with: 'Volunteer''s skills'.        ! !

!RemoveSkillView methodsFor: 'accessing' stamp: 'RG 11/2/2012 23:53'!
skills
	^skills ! !

!RemoveSkillView methodsFor: 'accessing' stamp: 'RG 11/2/2012 23:53'!
skills: list
	skills := list! !

WAComponent subclass: #SkillChooser
	instanceVariableNames: 'skills'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Showcase-Web'!

!SkillChooser methodsFor: 'accessing' stamp: 'RG 11/2/2012 23:29'!
add 
	self answer.! !

!SkillChooser methodsFor: 'accessing' stamp: 'RG 11/2/2012 23:33'!
addSkill: aSkill
	( skills includes: aSkill ) ifFalse: [
		skills add: aSkill.	
	]    ! !

!SkillChooser methodsFor: 'rendering' stamp: 'RG 11/2/2012 23:47'!
renderContentOn: html
	html form: [
		self renderTitleOn: html.
		html table: [  
			html tableRow: [  
				html tableHeading: 'Choose Skill'.
				html tableData: [
					html select 
   				         	list: (SkillCollection default collection);
						callback: [ :value | self addSkill: value. ].]. 
				self renderSubmitOn: html.    
			]
		]  
	].    ! !

!SkillChooser methodsFor: 'rendering' stamp: 'RG 11/2/2012 23:20'!
renderSubmitOn: html
	 html tableData: [  	
			html submitButton
				callback: [ self add  ];
				value: 'Add'. 
	].    ! !

!SkillChooser methodsFor: 'rendering' stamp: 'RG 11/2/2012 23:50'!
renderTitleOn: html
	html heading level: 2; with: 'Add a skill to Volunteer'.      ! !

!SkillChooser methodsFor: 'accessing' stamp: 'RG 11/2/2012 23:36'!
skills
	^ skills ! !

!SkillChooser methodsFor: 'accessing' stamp: 'RG 11/2/2012 23:36'!
skills: list
	skills := list ! !
LoginView initialize!
RegisterSkillView initialize!
RegisterVolunteerView initialize!
